/*

  in_cube Gamecube Stream Player for Winamp
  by hcs

  includes work by Destop, bero, El Barto, and Rob

*/

// not specific to formats

#include <windows.h>
#include "cube.h"

int get16bit(unsigned char* p)
{
	return (p[0] << 8) | p[1];
}

int get32bit(unsigned char* p)
{
	return (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
}

void fillbuffers(CUBEFILE * cf) {

	if (cf->ch[0].type==type_adx03 || cf->ch[0].type==type_adx04) {
		fillbufferADX(cf);
	} else if (cf->ch[0].type==type_adp) {
		fillbufferADP(cf);
	} else if (cf->ch[0].type==type_halp) {
		fillbufferHALP(cf);
	} else if (cf->ch[0].interleave) {
		fillbufferDSPinterleave(cf);
	} else {
		fillbufferDSP(&cf->ch[0]);
		if (cf->NCH==2)
			fillbufferDSP(&cf->ch[1]);
	}
}

void CloseCUBEFILE(CUBEFILE * cf) {
	if (cf->ch[0].infile != INVALID_HANDLE_VALUE) CloseHandle(cf->ch[0].infile);
	if (cf->ch[1].infile != cf->ch[0].infile && cf->ch[1].infile != INVALID_HANDLE_VALUE) CloseHandle(cf->ch[1].infile);
	cf->ch[0].infile=cf->ch[1].infile=INVALID_HANDLE_VALUE;
}